#include "polynomial.hpp"

Polynomial::Polynomial()
{
    for(auto i = 0; i <= MAX_DEGREE; ++i)
    {
        coeffs_[i] = 0.0f;
    }
}

void Polynomial::setCoeff(size_t n, float coeff)
{
    if( n <= MAX_DEGREE)
    {
        coeffs_[n] = coeff;
    }
}

float Polynomial::value(float arg) const
{
    float result = 0.0f;

    for(auto i = MAX_DEGREE+1; i; --i)
    {
        result = result * arg + coeffs_[i-1];
    }

    return result;
}

float Polynomial::coeff(size_t n) const
{
    if (n <= MAX_DEGREE)
    {
        return coeffs_[n];
    }
    else
    {
        return 0.0f;
    }
}

size_t Polynomial::degree() const
{
    size_t degree = 0;

    for(auto i = 0; i <= MAX_DEGREE; ++i)
    {
        if (0.0f != coeffs_[i]) 
        {
            degree = i;
        }
    } 

    return degree;
}
