#ifndef POLYNOMIAL_HPP
#define POLYNOMIAL_HPP

#include <cstddef> // size_t

class ConstSizePolynomial
{
public:
    ConstSizePolynomial(size_t degree = 5);
    ConstSizePolynomial(const ConstSizePolynomial&);
    ConstSizePolynomial(ConstSizePolynomial&&);

    ConstSizePolynomial& operator=(const ConstSizePolynomial&) = delete;

    ConstSizePolynomial& operator=(ConstSizePolynomial&&);

    void setCoeff(size_t n, float coeff);

    float value(float arg) const;
    float coeff(size_t n) const;
    size_t degree() const;

    ~ConstSizePolynomial();
private:
    size_t degree_;
    float * coeffs_;
};

class Polynomial
{
public:
    Polynomial();

    void setCoeff(size_t n, float coeff);

    float value(float arg) const;
    float coeff(size_t n) const;
    size_t degree() const;
private:
    void _resize(size_t degree);

    size_t currentPolynomialDegree_;
    ConstSizePolynomial polynomial_;
};

#endif // POLYNOMIAL_HPP
