#ifndef NEWTON_METHOD_HPP
#define NEWTON_METHOD_HPP

template<typename DerivativeMethod, typename T>
class NewtonMethod
{ 
public:
    NewtonMethod(const T& eps = static_cast<T>(1e-6));

    template<typename Polynomial>
    float solve(const Polynomial&, T = static_cast<T>(0));

private:
    T eps_;
};

#include "newton_method.ipp"

#endif // NEWTON_METHOD_HPP
