#include "polynomial_derivative.hpp"

template<typename T>
Polynomial<T> PolynomialDerivative::derive(const Polynomial<T>& p) const
{
    Polynomial<T> result;

    for(auto i = p.degree(); i > 0; --i)
    {
        if (static_cast<T>(0) != p.coeff(i))
        {
            result.setCoeff(i-1, p.coeff(i) * i);
        }
    }

    return result;
}
